# Flubber is just some simple, stupid bindings to use Elasticsearch as a plain old CRUD database.
# Create will make an id if you do not provide one; Read, Update, and Delete all require an id. 
# We also support a default index/type to make it really brain-dead to use. Huzzah!
# It sits on top of the vendor-provided elasticsearch gem - you can, and should, use the client
# this provides via client() to talk directly to elasticsearch if you need to be more savvy.  

# Why Flubber?
# - All the good names were taken?
# - Flubber is kind of a CRUDdy Elastic?
# - The original was pretty awesome. Jerry Lewis 4tW. 

class Flubber

   def initialize(a)
      @attr = { url: ENV['ELASTICSEARCH_URL'], index: 'test', type: 'test' }
      if !a.nil? then
         self.default(a) if a.class == Hash
         @attr[:url] = a if a.class == String
      end
      @client = Elasticsearch::Client.new url: @attr[:url]
   end

   def client
      return @client
   end

   # Copy key value from one hash to another, forcing key to sym, only if it exists
   def setval(dest, source, name)
      return unless source.class == Hash
      return if source[name].nil? and source[name.to_sym].nil?
      dest[name.to_sym] = source[name].to_s unless source[name].nil?
      dest[name.to_sym] = source[name.to_sym].to_s unless source[name.to_sym].nil?
      dest[name.to_sym] = source[name.to_s].to_s unless source[name.to_s].nil?
   end

   # Replace defaults
   def default(a)
      a.keys.each { |k| self.setval(@attr, a, k) }
   end

   def info
     @client.info 
   end

   def setup(a)
     q = { index: @attr[:index], type: @attr[:type] }
     if a.class == Hash then
       [:index, :type, :id].each { |k| self.setval(q, a, k) }
     else
       q[:id] = a.to_s
     end
     return q
   end

   def create(a, j)
      q = setup(a)
      j = j.to_s if j.respond_to?(:to_s)
      q[:body] = j
      @client.index q
   end

   def read(a)
     @client.get setup(a)
   end

   def update(a, j) # maybe add modify() that only changes some fields? hmmm. 
      q = setup(a)
      q[:body] = j
      @client.index q
   end

   def delete(a)
     @client.delete setup(a)
   end

   def search(a)
   end

end
